<?php

namespace Factory;

use Zeedhi\DevOps\Model\Configurationmanager\Entities\Package;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Product;
use Zeedhi\DevOps\Model\Servermanager\Entities\ProductServer as ProductServerEntity;
use Zeedhi\DevOps\Model\Servermanager\Entities\Server;

class ProductServer {
    /**
     * @param ProductServerEntity $productServer
     * @param $backupLimit
     * @param $path
     * @param Server $server
     * @param Product $product
     * @param Package $package
     * @param $execScriptsAuto
     * @return ProductServerEntity
     */
    public function save(ProductServerEntity $productServer = null, $backupLimit, $path,
                         Server $server, Product $product, Package $package, $execScriptsAuto) {
        if(!$productServer) {
            $productServer = new ProductServerEntity();
        }

        $productServer->setBackupLimit($backupLimit);
        $productServer->setPath($path);
        $productServer->setUsetype(ProductServerEntity::TYPE_PRODUCTION);
        $productServer->setServer($server);
        $productServer->setProduct($product);
        $productServer->setPackage($package);
        $productServer->setExecScriptsAutomatic($execScriptsAuto);

        return $productServer;
    }
} 