<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 29/05/17
 * Time: 14:29
 */

namespace Service\Login;

use Util\InstanceProvider;
use Util\Utilities;

class UserDataProvider extends \Teknisa\Libs\Util\Login\UserDataProvider{
    /** @var \Teknisa\Model\Geral\Repositories\Operador */
    protected $operadorRepository;
    public function __construct($repository, $activeDirectory,  $utilities,
                                 $entityManager,  $environment,  $connectionCustom){
        parent::__construct($repository, $activeDirectory,  $utilities,
            $entityManager,  $environment,  $connectionCustom);
    }

    public function getUserData($user, $password) {
        $userData = array( 'USER' => false );
        /** @var \Teknisa\Model\Geral\Repositories\Operador */
        $this->operadorRepository = $this->entityManager->getRepository('\Teknisa\Model\Geral\Entities\Operador');
        $operator = $this->operadorRepository->getOperatorByNmAccessOrEmail($user);
        if(!empty($operator) && $operator['ID']) {
            $this->updateEntityManagerVPD($operator);
            $userData['USER']           = $operator;
            $userData['ORGANIZATION']   = $this->repository->getOrganizacaoByNrorg($operator['ORGANIZATION_ID']);
            $accessProfile = $this->repository->getPerfAcessParcByNrorgAndNrParcNegocio($operator['ORGANIZATION_ID'], $operator['NRPARCNEGOCIO']);
            $userData['ACCESS_PROFILE'] = $accessProfile;

            $this->getPasswordParameters($operator['ID'], $operator['ORGANIZATION_ID'], $userData);
            $this->getOtherSessionValues($operator, $userData, $accessProfile);
            $this->getIpRestriction($operator['ORGANIZATION_ID'], $userData);

            if($password) {
                $this->validateAD($userData['PASSWORD_PARAMETERS'], $user, $password, $operator['ORGANIZATION_ID']);
            }
        }

        return $userData;
    }

    protected function getOtherSessionValues($operator, &$userData, $accessProfile) {
        $generalParams = $this->repository->getParamGeralByNrorg($operator['ORGANIZATION_ID']);
        $filial = $this->repository->getFilialByCdfilialAndNrorg($operator['CDFILIALSELECIONADA'], $operator['ORGANIZATION_ID']);
        $admUser = $this->verifyAdministratorUser($accessProfile, $generalParams);

        $userData['OTHER_SESSION_VALUES']['CDPICTPROD']        = isset($generalParams['CDPICTPROD']) ? $generalParams['CDPICTPROD'] : null;
        $userData['OTHER_SESSION_VALUES']['CDPICTPRAT']        = isset($generalParams['CDPICTPRAT']) ? $generalParams['CDPICTPRAT'] : null;
        $userData['OTHER_SESSION_VALUES']['IDIDIOMA']          = $operator['IDIDIOMA'];
        $userData['OTHER_SESSION_VALUES']['NRORGTRAB']         = $operator['NRORGTRAB'];
        $userData['OTHER_SESSION_VALUES']['NRESTRUTTRAB']      = $operator['NRESTRUTTRAB'];
        $userData['OTHER_SESSION_VALUES']['CDEMPRESA']         = $operator['CDEMPRESA'];
        $userData['OTHER_SESSION_VALUES']['NMACESSO']          = $operator['NMACESSO'];
        $userData['OTHER_SESSION_VALUES']['NMCOMPLOPER']       = $operator['NMCOMPLOPER'];
        $userData['OTHER_SESSION_VALUES']['NRPARCNEGOCIO']     = $operator['NRPARCNEGOCIO'];
        $userData['OTHER_SESSION_VALUES']['ACL_ADMINISTRATOR'] = $admUser;

        $sessionCdCliente = InstanceProvider::getSession()->get('CDCLIENTE');
        $userData['OTHER_SESSION_VALUES']['CDCLIENTE'] = empty($sessionCdCliente) ? $operator['CDCLIENTE'] : $sessionCdCliente;

        if(isset($filial['CDFILIAL'])) {
            $userData['OTHER_SESSION_VALUES']['CDFILIAL']  = $filial['CDFILIAL'];
            $userData['OTHER_SESSION_VALUES']['NMFILIAL']  = $filial['NMFILIAL'];
        }

    }
} 