/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CNPR                                                     */
/* Tabela : CONVPRODUTO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CNPR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CNPR
GO

CREATE TRIGGER DTULTATU_CNPR
ON CONVPRODUTO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONVPRODUTO', null, 'SGUNIDADE='+ SGUNIDADE+ ';'+
                                          'CDPRODUTO='+ CDPRODUTO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONVPRODUTO
      SET DTULTATUCNPR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CONVPRODUTO.VRFATOCONVES,0) = ISNULL(INSERTED.VRFATOCONVES,0)) AND
            (ISNULL(CONVPRODUTO.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))    AND
            (ISNULL(CONVPRODUTO.SGUNIDADE,0)    = ISNULL(INSERTED.SGUNIDADE,0));
   END;
END;
GO

