IF EXISTS(SELECT *
            FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_PRODRETI'
             AND TYPE   = 'TR'
             AND U.UID  = O.UID
             AND U.NAME = USER)

   DROP TRIGGER LOG_GER_PRODRETI
GO

CREATE TRIGGER LOG_GER_PRODRETI
ON PRODRETI
FOR UPDATE, INSERT, DELETE
AS
BEGIN
   DECLARE @V_USUARIO      VARCHAR(40);
   DECLARE @V_TIPO         VARCHAR(01);
   DECLARE @V_TPMOVI       VARCHAR(01);
   DECLARE @V_ITPESQ       VARCHAR(40);
   DECLARE @V_DESC         VARCHAR(700);
   DECLARE @V_CDFILLOGOPER VARCHAR(04);
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DTOPER       DATETIME;

   /* ****INCIO DAS VARIVEIS DO C_CURSOR***** */
   DECLARE @V_OLD_CDTIPORETI   VARCHAR(02);
   DECLARE @V_OLD_CDPRODRETI   VARCHAR(10);

   DECLARE @V_NEW_CDTIPORETI   VARCHAR(02);
   DECLARE @V_NEW_CDPRODRETI   VARCHAR(10);
   /* ****FINAL DAS VARIVEIS DO C_CURSOR***** */

   SET @V_TIPO         = '0';
   SET @V_DESC         = '';
   SET @V_CDFILLOGOPER = '';
   SET @V_USUARIO      = '-';

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL,
         NULL,
         DELETED.CDTIPORETI,
         DELETED.CDPRODRETI
      FROM
         DELETED
      WHERE
         0 = (SELECT
                 COUNT(*)
              FROM
                 INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDTIPORETI,
         INSERTED.CDPRODRETI,
         DELETED.CDTIPORETI,
         DELETED.CDPRODRETI
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDTIPORETI = DELETED.CDTIPORETI   AND
         INSERTED.CDPRODRETI = DELETED.CDPRODRETI

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDTIPORETI,
         INSERTED.CDPRODRETI,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT
                 COUNT(*)
              FROM
                 DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_TIPO,
                                 @V_NEW_CDTIPORETI,
                                 @V_NEW_CDPRODRETI,
                                 @V_OLD_CDTIPORETI,
                                 @V_OLD_CDPRODRETI;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      /* DELETE */
      IF @V_TIPO = 'D' BEGIN
         SET @V_TPMOVI       = '3';
         SET @V_ITPESQ       = @V_OLD_CDTIPORETI + @V_OLD_CDPRODRETI;

         IF @V_OLD_CDTIPORETI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoReti=' + @V_OLD_CDTIPORETI;
         END;

         IF @V_OLD_CDPRODRETI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Produto=' + @V_OLD_CDPRODRETI;
         END;
      END
      ELSE BEGIN
         /* UPDATE */
         IF @V_TIPO = 'U' BEGIN
            IF (ISNULL(@V_OLD_CDTIPORETI, '!') <> ISNULL(@V_NEW_CDTIPORETI, '!')) OR
               (ISNULL(@V_OLD_CDPRODRETI, '!') <> ISNULL(@V_NEW_CDPRODRETI, '!'))
            BEGIN
               SET @V_TPMOVI       = '2';
               SET @V_ITPESQ       = @V_OLD_CDTIPORETI + @V_OLD_CDPRODRETI;
            END;
         END
         ELSE BEGIN
            /* INSERT */
            SET @V_TPMOVI        = '1';
            SET @V_ITPESQ        = @V_NEW_CDTIPORETI + @V_NEW_CDPRODRETI;
         END;

         IF ISNULL(@V_NEW_CDTIPORETI, '!') <> ISNULL(@V_OLD_CDTIPORETI, '!') BEGIN
            SET @V_DESC = @V_DESC + ' TipoReti=' + @V_NEW_CDTIPORETI;
         END;

         IF ISNULL(@V_NEW_CDPRODRETI, '!') <> ISNULL(@V_OLD_CDPRODRETI, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Produto=' + @V_NEW_CDPRODRETI;
         END;

      END;

      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @P_NMUSUARIO    = @V_USUARIO OUTPUT;
         EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                         @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                         @P_DSSERVERRDM  = @V_DSSERVERRDM  OUTPUT,
                         @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                         @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;
         SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,
                   DTOPERACAO,
                   NMRESPOPER,
                   IDTIPOOPER,
                   CDPESQITEM,
                   DSOPERACAO,
                   CDFILLOGOPER,
                   DSRDMUSUOPER,
                   DSENDUSUOPER,
                   DSNMUSUOPER,
                   DSMETUSUOPER,
                   CDORESPOPER)
               VALUES
                  ('PRODRETI',
                   @V_DTOPER,
                   @V_USUARIO,
                   @V_TPMOVI,
                   @V_ITPESQ,
                   SUBSTRING(@V_DESC,1,700),
                   @V_CDFILLOGOPER,
                   @V_DSSERVERRDM,
                   @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_TIPO,
                                    @V_NEW_CDTIPORETI,
                                    @V_NEW_CDPRODRETI,
                                    @V_OLD_CDTIPORETI,
                                    @V_OLD_CDPRODRETI;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_PRODRETI','6.05.XXX';
GO
